#COMPILE DLL "prepoffs2"
#REGISTER NONE
#DEBUG ERROR OFF
#TOOLS OFF
#DIM ALL

#IF 0
#RESOURCE "prepoffs2.pbr"
#ENDIF

#INCLUDE "win32api.inc"

GLOBAL hInst AS DWORD

GLOBAL hookpoffs2 AS LONG
GLOBAL hprocpoffs2 AS DWORD

%MOD_ALT                 = &H00000001
%MOD_SHIFT               = &H00000004

FUNCTION LIBMAIN (BYVAL hInstance AS DWORD, BYVAL reason AS DWORD, BYVAL reserved AS DWORD) AS LONG
    SELECT CASE reason
        CASE %DLL_PROCESS_ATTACH
            hInst = hInstance
            FUNCTION = 1
        CASE %DLL_PROCESS_DETACH
            IF hookpoffs2 <> %NULL THEN UnhookWindowsHookEx hookpoffs2
    END SELECT
END FUNCTION

FUNCTION GetDefaultPrinterClay AS STRING
    FUNCTION = ""
    LOCAL wx AS ASCIIZ*512, hlib AS DWORD, hproc AS DWORD, d AS DWORD, L AS LONG
    GetProfileString "Windows", "Device", "none", wx, SIZEOF(wx)
    IF wx = "none" THEN
        hlib = LoadLibrary("winspool.drv")
        IF hlib <> %NULL THEN
            hproc = GetProcAddress(hlib, "GetDefaultPrinterA")
            IF hproc <> %NULL THEN
                d = SIZEOF(wx)
                ! pushad
                ! pushfd
                ! lea eax, d
                ! push eax
                ! lea eax, wx
                ! push eax
                ! call hproc
                ! mov L, eax
                ! popfd
                ! popad
                IF ISTRUE L THEN
                    FUNCTION = wx
                END IF
            END IF
            FreeLibrary hlib
        END IF
    ELSE
        FUNCTION = TRIM$(PARSE$(wx, ",", 1))
    END IF
END FUNCTION

FUNCTION MakeFont (BYVAL hdc AS DWORD, BYVAL A AS STRING, BYVAL B AS LONG) AS LONG
    FUNCTION = %NULL
    IF (LEN(A) = 0) OR (B = 0) THEN EXIT FUNCTION
    LOCAL x AS LOGFONT, flaga AS LONG
    IF hdc = 0 THEN
        hdc = GetDC(%HWND_DESKTOP)
        flaga = -1
    END IF
    x.lffacename = A
    x.lfheight = (B * GetDeviceCaps(hdc, %LOGPIXELSY)) \ 72
    FUNCTION = CreateFontIndirect(x)
    IF flaga THEN
        ReleaseDC %HWND_DESKTOP, hdc
    END IF
END FUNCTION

FUNCTION DoExtent (BYVAL s AS STRING, BYVAL hdc AS DWORD, BYVAL count AS LONG) AS STRING
    FUNCTION = ""
    REPLACE $CRLF WITH $LF IN s
    REPLACE $CR WITH $LF IN s
    s = RTRIM$(s, $LF)
    IF LEN(s) = 0 THEN EXIT FUNCTION
    REDIM z(1 TO PARSECOUNT(s, $LF)) AS LOCAL STRING
    PARSE s, z(), $LF
    LOCAL L AS LONG, L1 AS LONG, L2 AS LONG
    LOCAL px AS ASCIIZ*8190, xsize AS apiSIZE
    LOCAL s1 AS STRING, s2 AS STRING, s3 AS STRING
    L = 1
    WHILE L <= UBOUND(z)
        IF UBOUND(z) = &H7FFFFFFF& THEN EXIT LOOP
        px = z(L)
        GetTextExtentExPoint hdc, px, LEN(px), count, L2, BYVAL 0, xsize
        IF LEN(z(L)) > L2 THEN
            s2 = LEFT$(z(L), L2)
            s3 = MID$(z(L), L2 + 1)
            FOR L1 = LEN(s2) TO MAX(1, LEN(s2) - 20) STEP -1
                IF MID$(s2, L1, 1) = $SPC THEN
                    s3 = MID$(s2, L1 + 1) + s3
                    s2 = LEFT$(s2, L1 - 1)
                    EXIT FOR
                END IF
            NEXT
            z(L) = s2
            REDIM PRESERVE z(1 TO UBOUND(z) + 1)
            ARRAY INSERT z(L + 1), s3
        END IF
        INCR L
    WEND
    FUNCTION = JOIN$(z(), $CRLF)
END FUNCTION

FUNCTION PrintA (BYVAL s AS STRING) AS LONG
    FUNCTION = 0
    IF LEN(s) = 0 THEN EXIT FUNCTION
    LOCAL szprinter AS STRING
    szprinter = GetDefaultPrinterClay()
    IF szprinter = "" THEN EXIT FUNCTION
    LOCAL LLines AS LONG
    LOCAL LExtY AS LONG
    LOCAL LX AS LONG, LY AS LONG, LOffsetX AS LONG, LOffsetY AS LONG
    LOCAL hdc AS DWORD, hfont AS LONG, hfont2 AS LONG
    LOCAL di AS DOCINFO, sdoc AS STRING
    sdoc = "Clay's Document - " + DATE$ + " - " + TIME$
    di.cbsize = LEN(di)
    di.lpszdocname = STRPTR(sdoc)
    hdc = CreateDC(BYVAL 0, BYVAL STRPTR(szprinter), BYVAL 0, BYVAL 0)
    IF hdc = %NULL THEN
        EXIT FUNCTION
    END IF
    hfont = MakeFont(hdc, "Courier", 10)
    IF hfont = %NULL THEN
        DeleteDC hdc
        EXIT FUNCTION
    END IF
    hfont2 = SelectObject(hdc, hfont)
    LOffsetX = GetDeviceCaps(hdc, %PHYSICALOFFSETX)
    LOffsetY = GetDeviceCaps(hdc, %PHYSICALOFFSETY)
    LX = GetDeviceCaps(hdc, %PHYSICALWIDTH) - LOffsetX - FIX(0.75! * GetDeviceCaps(hdc, %LOGPIXELSX))
    LY = GetDeviceCaps(hdc, %PHYSICALHEIGHT) - LOffsetY - GetDeviceCaps(hdc, %LOGPIXELSY)
    LOCAL tm AS TEXTMETRIC
    GetTextMetrics hdc, tm
    LExtY = (tm.tmheight + tm.tmexternalleading)
    s = DoExtent(s, hdc, LX)
    IF LEN(s) = 0 THEN
        SelectObject hdc, hfont2
        DeleteDC hdc
        DeleteObject hfont
        EXIT FUNCTION
    END IF
    LLines = LY \ LExtY
    IF StartDoc(hdc, di) =< 0 THEN
        SelectObject hdc, hfont2
        DeleteDC hdc
        DeleteObject hfont
        EXIT FUNCTION
    END IF
    LOCAL L AS LONG, L1 AS LONG
    LOCAL rc AS RECT, s1 AS STRING
    LOCAL dcolor AS DWORD
    dcolor = 0
    SelectObject hdc, hfont2
    RESET L
    StartPage hdc
    SetBkMode hdc, %TRANSPARENT
    SetTextColor hdc, dcolor
    hfont2 = SelectObject(hdc, hfont)
    rc.nleft = LOffsetX
    rc.nright = rc.nleft + LX
    rc.ntop = LOffsetY
    rc.nbottom = rc.ntop + LExtY
    FOR L1 = 1 TO PARSECOUNT(s, $CRLF)
        s1 = PARSE$(s, $CRLF, L1)
        DrawText hdc, BYCOPY s1, -1, rc, %DT_SINGLELINE OR %DT_NOPREFIX OR %DT_VCENTER OR %DT_LEFT
        rc.ntop = rc.ntop + LExtY
        rc.nbottom = rc.nbottom + LExtY
        INCR L
        IF L = LLines THEN
            IF L1 = PARSECOUNT(s, $CRLF) THEN EXIT FOR
            RESET L
            SelectObject hdc, hfont2
            EndPage hdc
            StartPage hdc
            rc.ntop = LOffsetY
            rc.nbottom = rc.ntop + LExtY
            hfont2 = SelectObject(hdc, hfont)
            SetBkMode hdc, %TRANSPARENT
            SetTextColor hdc, dcolor
        END IF
    NEXT
    SelectObject hdc, hfont2
    EndPage hdc
    EndDoc hdc
    DeleteDC hdc
    DeleteObject hfont
    FUNCTION = -1
END FUNCTION

SUB HookPoffs (BYVAL A AS DWORD) EXPORT
    IF hookpoffs2 = %NULL THEN hookpoffs2 = SetWindowsHookEx(%WH_CALLWNDPROCRET, CODEPTR(hookfpoffs2), hInst, A)
    LOCAL L AS LONG
    L = FindWindow("Clay's PrePoffs2", HEX$(A, 8))
    IF L <> %NULL THEN SetWindowLong L, 36, hookpoffs2
END SUB

FUNCTION hookfpoffs2 (BYVAL A AS LONG, BYVAL B AS LONG, BYVAL C AS DWORD) AS LONG
    STATIC hhook AS LONG, hwnd2 AS LONG
    IF hwnd2 = %NULL THEN
        hwnd2 = FindWindow("Clay's PrePoffs2", HEX$(GetCurrentThreadId(), 8))
        IF hwnd2 <> %NULL THEN
            IF hhook = %NULL THEN
                hhook = GetWindowLong(hwnd2, 36)
            END IF
        END IF
    END IF
    IF A < 0 THEN FUNCTION = CallNextHookEx(hhook, A, B, C)
    LOCAL x AS CWPRETSTRUCT PTR
    x = C
    STATIC init AS LONG, hwnd AS LONG, hiconhookpoffs2 AS LONG
    LOCAL wx AS ASCIIZ*512
    IF ISFALSE init THEN
        GetClassName @x.hwnd, wx, SIZEOF(wx)
        IF wx = "#32770" THEN
            init = -1
            hwnd = @x.hwnd
            hiconhookpoffs2 = LoadImage(hInst, "DIALOGICON", %IMAGE_ICON, 0, 0, 0)
            IF hiconhookpoffs2 <> %NULL THEN
                SendMessage hwnd, %WM_SETICON, %ICON_BIG, hiconhookpoffs2
                SendMessage hwnd, %WM_SETICON, %ICON_SMALL, hiconhookpoffs2
            END IF
            hprocpoffs2 = SetWindowLong(hwnd, %DWL_DLGPROC, CODEPTR(Proc1Poffs2))
            RegisterHotKey hwnd, &H0BFFF, %MOD_ALT OR %MOD_SHIFT, %VK_P
        END IF
    END IF
    IF @x.hwnd = hwnd THEN
        IF ((@x.message AND &H0FFFF) = %WM_NCDESTROY) THEN
            IF hwnd2 <> %NULL THEN PostMessage hwnd2, %WM_SYSCOMMAND, %SC_CLOSE, 0
            IF hiconhookpoffs2 <> %NULL THEN DestroyIcon hiconhookpoffs2
        END IF
    END IF
    FUNCTION = CallNextHookEx(hhook, A, B, C)
END FUNCTION

FUNCTION Proc1Poffs2 (BYVAL hwnd AS DWORD, BYVAL wmsg AS DWORD, BYVAL wparam AS LONG, BYVAL lparam AS LONG) AS LONG
    STATIC hwnd2 AS LONG
    IF hwnd2 = %NULL THEN
        hwnd2 = GetDlgItem(hwnd, 1074)
    END IF
    STATIC init AS LONG
    IF ISFALSE init THEN
        init = -1
        GLOBAL hprocedm AS DWORD
        hprocedm = SetWindowLong(GetDlgItem(hwnd, 1074), %GWL_WNDPROC, CODEPTR(SubclassEdm))
    END IF
    SELECT CASE wmsg
        CASE %WM_DESTROY
            UnregisterHotKey hwnd, &H0BFFF
            SetWindowLong hwnd, %DWL_DLGPROC, hprocpoffs2
        CASE %WM_HOTKEY
            IF wparam = &H0BFFF THEN
                LOCAL L AS LONG, s AS STRING
                L = SendMessage(hwnd2, %WM_USER + 141, 0, 0)
                IF L > 0 THEN
                    s = SPACE$(L)
                    SendMessage hwnd2, %WM_USER + 140, STRPTR(s), LEN(s)
                    IF LEN(s) THEN
                        IF s <> SPACE$(LEN(s)) THEN
                            PrintA s
                        END IF
                    END IF
                END IF
                EXIT FUNCTION
            END IF
        CASE %WM_MOUSEWHEEL
            LOCAL pt AS POINTAPI
            GetCursorPos pt
            LOCAL hwndctrl AS LONG
            hwndctrl = WindowFromPoint(pt.x, pt.y)
            IF hwndctrl <> %NULL THEN
                SELECT CASE GetDlgCtrlId(hwndctrl)
                    CASE 1064, 1074
                        LOCAL i AS INTEGER
                        i = HIINT(wparam)
                        IF ABS(i) => 120 THEN
                            LOCAL L1 AS LONG
                            FOR L1 = 1 TO ABS(i) \ 120
                                SendMessage hwndctrl, %WM_VSCROLL, IIF(i > 0, %SB_LINEUP, %SB_LINEDOWN), 0
                            NEXT
                            EXIT FUNCTION
                        END IF
                    CASE ELSE
                END SELECT
            END IF
    END SELECT
    FUNCTION = CallWindowProc(hprocpoffs2, hwnd, wmsg, wparam, lparam)
END FUNCTION

FUNCTION SubclassEdm (BYVAL hwnd AS DWORD, BYVAL wmsg AS DWORD, BYVAL wparam AS DWORD, BYVAL lparam AS DWORD) AS LONG
    SELECT CASE wmsg
        CASE %WM_DESTROY
            SetWindowLong hwnd, %GWL_WNDPROC, hprocedm
        CASE %WM_MOUSEWHEEL
            FUNCTION = DefWindowProc(hwnd, wmsg, wparam, lparam)
            EXIT FUNCTION
    END SELECT
    FUNCTION = CallWindowProc(hprocedm, hwnd, wmsg, wparam, lparam)
END FUNCTION
